#!/usr/bin/perl

#######################################################################
# Trillian 'Buddies.xml' to 'centericq' contanct list import utility  #
# This works for version 1.0 Xbuddy xml file                          #
# This program is distributed under the Gnu Public License (GPL)      #
# Version 0.62 , release  date 13/8/2003                                #
# Author: Vassilios Karakoidas - bkarak@aueb.gr (2003)                #
#######################################################################

# configuration variables

$TRILLIAN_BUDDY_LIST = "Buddies.xml";
$OUTPUT_DIR          = "/";

# statics
$VERSION    = "0.62";

# global valriables

$ICQ_COUNT        = 0;
$MSN_COUNT        = 0;
$IMPORT_MSN_COUNT = 0;
$IMPORT_ICQ_COUNT = 0;

# functions

sub fix_url_encoded{
    $_[0] =~ s/%([0-9A-Za-z]{2})/pack("H2",$1)/ge;
}

sub create_account_icq{
    if(!(-d $OUTPUT_DIR.$_[0])){
	if(!mkdir($OUTPUT_DIR.$_[0])){
	    print "Creation of ".$_[0]." failed\n";
	}else{
	    print "Found new ICQ  account - ".$_[0]." (".$_[1].")\n";
	    $IMPORT_ICQ_COUNT++;
	}
    }else{ print "ICQ Account ".$_[0]." (".$_[1].")"." already exists\n"; }
}

sub create_account_msn{
    local(@buddy_mail) = split("@",$_[0]);
    local($buddy_dir) = $OUTPUT_DIR."m".$buddy_mail[0];
    if(!(-d $buddy_dir)){
	if(!mkdir($buddy_dir)){
	    print "Creation of ".$buddy_mail[0]." failed\n";
	}else{
	    print "Found new MSN account - ".$buddy_mail[0]."\n";
	    # create the partial info file
	    open(INFO_FP,">".$buddy_dir."/info");
	    print INFO_FP $buddy_mail[0]."\n\n\n".$_[0]."\n";
	    close(INFO_FP);
	    # created ok
	    $IMPORT_MSN_COUNT++;
	}
    }else{ print "MSN Account ".$buddy_mail[0]."  already exists\n"; }
}

# main program

# print initial information

print "trillian_convert.pl version ".$VERSION."\n";
print "Trillian 'Buddies.xml' to 'centericq' contanct list import utility\n";
print "This program is distributed under the Gnu Public License\n";
print "Author: Vassilios Karakoidas email:bkarak@aueb.gr\n";
print "--- Output ---\n";

# start import
open(TRILLIAN_XML,$TRILLIAN_BUDDY_LIST);
@lines = <TRILLIAN_XML>;

foreach(@lines){
    if($_ =~ /\<buddy uri=\"ICQ:1%3A(.*)\"\>(.*)\<\/buddy\>/){
	$ICQ_COUNT++;
	@buddy_array = split("%3A",$1);
	create_account_icq($buddy_array[0],$2);
    }elsif($_ =~ /\<buddy uri=\"MSN:1%3A(.*)\"\>(.*)\<\/buddy\>/){
	$MSN_COUNT++;
	@buddy_array = split("%3A",$1);
	fix_url_encoded($buddy_array[0]);
	create_account_msn($buddy_array[0]);
    }
}

close(TRILLIAN_XML);

if(($IMPORT_MSN_COUNT == 0) && ($IMPORT_ICQ_COUNT == 0)){
    print "No new accounts imported.\n";
}

# print summary information
print "--- Summary information --- \n";
print "Found ".$ICQ_COUNT." ICQ accounts and imported ".$IMPORT_ICQ_COUNT."\n";
print "Found ".$MSN_COUNT." MSN accounts and imported ".$IMPORT_MSN_COUNT."\n";
print "Imported ".($IMPORT_ICQ_COUNT + $IMPORT_MSN_COUNT)." new accounts\n";
print "Processed totally ".($ICQ_COUNT + $MSN_COUNT)." accounts\n";